<?php
/**
* @version		$Id: plg_com_weblinks.php,v 1.1 2008/05/04 13:43:10 pythontech Exp $
* @package		pt_smartsef_weblinks
* @subpackage	Admin
* @copyright	Copyright 2008 Python Technology Ltd
* @license		GNU/GPL, see LICENSE.php
*
*/

/*-----------------------------------------------------------------------
 *	Convert non-SEF URLs produced by weblinks
 *	All have ?option=com_weblinks&Itemid=35
 *-----------------------------------------------------------------------*/
function WeblinksBuildRoute($query)
{
  global $_ptsef_weblinks;
  $db =& JFactory::getDBO();
  $qu = $query;
  $segments = array();
  /*-- Fetch the parameter settings for the plugin.  Use global alias parameter to avoid multiple sql queries */
  if ($_ptsef_weblinks == NULL) {
    $sql = "SELECT params FROM #__smartsef_plugins WHERE plugin='plg_com_weblinks'" ;
    $db->setQuery($sql);
    $params = $db->loadResult();
    $jp = new JParameter($params);
    $_ptsef_weblinks =
      array('prefix' => $jp->get('prefix','weblinks'),
	    'link_category' => $jp->get('link_category', 1));
  }

  if ($_ptsef_weblinks['prefix'] != '') {
    $segments[] = $_ptsef_weblinks['prefix'];
  }

  $view = _ptsefwl_get($qu,'view');
  if ($view == 'categories') {
    /* Nothing more to add */

  } elseif ($view == 'category') {
    /* e.g. "weblinks/category2" */
    $slug = _ptsefwl_get($qu,'id');
    $name = _ptsefwl_alias($slug,'category');
    $segments[] = $name;
    //$slug = _ptsefwl_get($qu,'catid');
    //$name = _ptsefwl_alias($slug,'category');
    //$segments[] = 'cat-'.$name;
    /* Remove redundant catid=n */
    unset($qu['catid']);
    $format = _ptsefwl_get($qu,'format');
    if ($format == '') {
      // Normal view
    } elseif ($format == 'feed') {
      // rss or atom
      $type = _ptsefwl_get($qu,'type');
      $segments[] = $type;
    } else {
      $segments[] = $format;
    }

  } elseif ($view == 'weblink') {
    $layout = _ptsefwl_get($qu,'layout');
    if ($layout == 'form') {
      /* Form to submit a link, e.g. "weblinks/submit" */
      $segments[] = 'submit-link';

    } else {
      /* Single link e.g. "weblinks/link35" */
      $catslug = _ptsefwl_get($qu,'catid');
      if ($_ptsef_weblinks['link_category']) {
	$catname = _ptsefwl_alias($catslug,'category');
	$segments[] = $catname;
      }
      $slug = _ptsefwl_get($qu,'id');
      $name = _ptsefwl_alias($slug,'link');
      $segments[] = $name;
    }

  } else {
    /* Unknown view */
    $segments[] = $view;
  }

  /*--- Append any other guff */
  _ptsefwl_get($qu,'option');
  _ptsefwl_get($qu,'Itemid');
  if (isset($qu)) {
    foreach ($qu as $param => $value) {
      $segments[] = $param.'-'.$value;
    }
  }

  return $segments;
}

function _ptsefwl_alias($slug,$prefix='')
{
  $ia = explode(':',$slug);
  if (0) {
    /* debugging */
    $name = $prefix;
    $name .= "-count-".count($ia);
    $name .= "-i0-".$isalias[0];
    if (count($ia) > 1) {
      $name .= "-i1-".$ia[1];
    }
  } else {
    if (count($ia) == 1 or $ia[1] == '') {
      $name = $prefix.$ia[0];
    } else {
      $name = $ia[1];
    }
  }
  return $name;
}

function _ptsefwl_get(&$arr,$key,$dflt='')
{
  if (array_key_exists($key,$arr)) {
    $value = $arr[$key];
    unset($arr[$key]);
  } else {
    $value = $dflt;
  }
  return $value;
}

?>
